<?php
/**
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * No redistribute in other sites, or copy.
 *
 * @author    RSI <rsi_2004@hotmail.com>
 * @copyright 2007-2014 RSI
 * @license   http://catalogo-onlinersi.net
 */

class Customize extends Module
{

	private $_html = '';
	private $_postErrors = array();

	public function __construct()
	{
		$this->name = 'customize';
		if (_PS_VERSION_ < '1.4.0.0')
			$this->tab = 'Blocks';
		if (_PS_VERSION_ > '1.4.0.0')
		{
			$this->tab           = 'front_office_customize';
			$this->author        = 'RSI';
			$this->need_instance = 1;
		}

		if (_PS_VERSION_ > '1.6.0.0')
			$this->bootstrap = true;
			$this->version = '1.7.0';

		parent::__construct();

		$this->displayName = $this->l('Visible customization');
		$this->description = $this->l('Show customization fields in more visible place- www.catalogo-onlinersi.net');
		if (_PS_VERSION_ < '1.5')
			require(_PS_MODULE_DIR_.$this->name.'/backward_compatibility/backward.php');

	}

	public function install()
	{
		if (_PS_VERSION_ < '1.6.0.0'){
		if (!Configuration::updateValue('CUSTOMIZE_DISABLE', 'yes') || !parent::install() || !$this->registerHook('extraright') || !$this->registerHook('header'))
			return false;
		}
		else
		if (!Configuration::updateValue('CUSTOMIZE_DISABLE', 'yes') || !Configuration::updateValue('CUSTOMIZE_ITEMCOUNT', '3') ||!parent::install() || !$this->registerHook('extraleft') || !$this->registerHook('header'))
			return false;
		chmod('../themes/'._THEME_NAME_.'/product.tpl', 0777);
		$str = '';

		if ($fh = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'r'))
		{
			while (!feof($fh))
			
				$str .= fgets($fh);
			

			if (_PS_VERSION_ < '1.5.0.0')

				$str = str_replace('<ul class="idTabs">', '<ul class="idTabs" style="display:none">', $str);

			if (_PS_VERSION_ > '1.5.0.0' && _PS_VERSION_ < '1.6.0.0')
				$str = str_replace('<div id="idTab10" class="bullet customization_block">', '<div id="idTab10" class="bullet customization_block" style="display:none">', $str);



			fclose($fh);
			@chmod('../themes/'._THEME_NAME_.'/product.tpl', 0644);
		}
		else
		
			die ('Error opening file in '.__FILE__.' on line '.__LINE.'.');
		
		$x42 = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'w');
		fwrite($x42, $str);



		return true;
	}

	public function displayForm()
	{
		$this->_html .= '
		<fieldset>
		
  <form action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data">
		<label>'.$this->l('Disable product customization tab').'</label>
	<div class="margin-form">
  <select name="disable" >
  <option value="yes"'.((Configuration::get('CUSTOMIZE_DISABLE') == 'yes') ? 'selected="selected"' : '').'>Yes</option>
	  <option value="no"'.((Configuration::get('CUSTOMIZE_DISABLE') == 'no') ? 'selected="selected"' : '').'>No</option>
    </select>
<p class="clear">'.$this->l('This disable the customize tab in bottom of product page').'</p>
		
		</div>
		<center><input type="submit" name="submitCustomize" value="'.$this->l('Save').'" class="button" /></center><br/>
  			<center>	<a href="../modules/customize/moduleinstall.pdf">README</a></center><br/>	
			<center>	<a href="../modules/customize/termsandconditions.pdf">TERMS</center></a><br/>	
			
			<p>'.$this->l('To disable the default PrestaShop customization fields in product page, just enable the option and select the position. If you dont know, just try one by one or remove directly the customization section in product.tpl of your template').'</p>
		<p>'.$this->l('Create massive custom fields for products with this module: Custom Fields Evolution').' <a href="http://catalogo-onlinersi.net/en/back-office-prestashop-modules/216-custom-fields-prestashop-module.html" target="_blank">Link</a></p>	
			<p>Other products</p>
  							<object type="text/html" data="http://catalogo-onlinersi.net/modules/productsanywhere/images.php?idproduct=&desc=yes&buy=yes&type=home_default&price=yes&style=false&color=10&color2=40&bg=ffffff&width=800&height=310&lc=000000&speed=5&qty=15&skip=29,14,42,44,45&sort=1" width="800" height="310" style="border:0px #066 solid;"></object>
<p>Video</p>
<iframe width="560" height="315" src="https://www.youtube.com/embed/TWxPyKXwCE8" frameborder="0" allowfullscreen></iframe>
  		</form>
		
    </fieldset>
	<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
			<fieldset><legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Contribute').'</legend>
				<p class="clear">'.$this->l('You can contribute with a donation if our free modules and themes are usefull for you. Clic on the link and support us!').'</p>
				<p class="clear">'.$this->l('For more modules & themes visit: www.catalogo-onlinersi.net').'</p>
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="HMBZNQAHN9UMJ">
<input type="image" src="https://www.paypalobjects.com/WEBSCR-640-20110401-1/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypalobjects.com/WEBSCR-640-20110401-1/en_US/i/scr/pixel.gif" width="1" height="1">
	</fieldset>
</form>
	';






		return $this->_html;
	}

	public function postProcess()
	{
		$errors = '';
		$output = '';
		if (Tools::isSubmit('submitCustomize'))
		{


			if ($disable = Tools::getValue('disable'))
				Configuration::updateValue('CUSTOMIZE_DISABLE', $disable);
			elseif (Shop::getContext() == Shop::CONTEXT_SHOP || Shop::getContext() == Shop::CONTEXT_GROUP)
				Configuration::deleteFromContext('CUSTOMIZE_DISABLE');
	if ($itemcount = Tools::getValue('itemcount'))
				Configuration::updateValue('CUSTOMIZE_ITEMCOUNT', $itemcount);
			elseif (Shop::getContext() == Shop::CONTEXT_SHOP || Shop::getContext() == Shop::CONTEXT_GROUP)
				Configuration::deleteFromContext('CUSTOMIZE_ITEMCOUNT');
			chmod('../themes/'._THEME_NAME_.'/product.tpl', 0777);
			$str  = '';
			$str2 = '';
			if ($fh = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'r'))
			{
				while (!feof($fh))
				
					$str .= fgets($fh);
				

				if ($disable == 'yes')
				{
					if (_PS_VERSION_ < '1.5.0.0')
					
						$str = str_replace('<ul class="idTabs">', '<ul class="idTabs" style="display:none">', $str);
					
					if (_PS_VERSION_ > '1.5.0.0' && _PS_VERSION_ < '1.6.0.0')
					
						$str = str_replace('<div id="idTab10" class="bullet customization_block">', '<div id="idTab10" class="bullet customization_block" style="display:none">', $str);

					
					if (_PS_VERSION_ > '1.6.0.0')
					
						$str = str_replace('<!--Customization -->', '<!-- Customization --><div id="rsic">', $str);
					
				}

				if ($disable == 'no')
				{
					if (_PS_VERSION_ < '1.5.0.0')
					

						$str = str_replace('<ul class="idTabs" style="display:none">', '<ul class="idTabs">', $str);
					
					if (_PS_VERSION_ > '1.5.0.0' && _PS_VERSION_ < '1.6.0.0')
					
						$str = str_replace('<div id="idTab10" class="bullet customization_block" style="display:none">', '<div id="idTab10" class="bullet customization_block">', $str);

					
				}
				fclose($fh);
				@chmod('../themes/'._THEME_NAME_.'/product.tpl', 0644);
			}
			else
			
				die ('Error opening file in '.__FILE__.' on line '.__LINE.'.');
			
			$x42 = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'w');
			fwrite($x42, $str);
			/**/
			if ($fh2 = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'r'))
			{
				while (!feof($fh2))
				
					$str2 .= fgets($fh2);
				

				if ($disable == 'yes')
				{

					if (_PS_VERSION_ > '1.6.0.0')

						$str2 = str_replace('<!--end Customization -->', '<!-- end Customization --></div>', $str2);

				}


				fclose($fh2);
				@chmod('../themes/'._THEME_NAME_.'/product.tpl', 0644);
			}
			else
			
				die ('Error opening file in '.__FILE__.' on line '.__LINE.'.');
			
			$x422 = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'w');
			fwrite($x422, $str2);

			$output .= $this->displayConfirmation($this->l('Settings updated.').'<br/>');

			//if (!$errors)
			return $output;

		}
	}

	public function getConfigFieldsValues()
	{
		$fields_values = array(
			'disable' => Tools::getValue('disable', Configuration::get('CUSTOMIZE_DISABLE')),

'itemcount' => Tools::getValue('itemcount', Configuration::get('CUSTOMIZE_ITEMCOUNT')),

		);
		return $fields_values;
	}

	public function renderForm()
	{
		$options1 = array(
			array(
				'id_option' => 'yes',
				// The value of the 'value' attribute of the <option> tag.
				'name'      => 'yes'
				// The value of the text content of the  <option> tag.
			),
			array(
				'id_option' => 'no',
				'name'      => 'no'
			),

		);

		$fields_form                      = array(
			'form' => array(
				'legend'      => array(
					'title' => $this->l('Configuration'),
					'icon'  => 'icon-cogs'
				),
				'input'       => array(

					array(
						'type'    => 'select',
						'label'   => $this->l('Disable product customization tab'),
						'name'    => 'disable',
						'desc'    => $this->l('This disable the customize tab in bottom of product page'),
						'options' => array(
							'query' => $options1,
							'id'    => 'id_option',
							'name'  => 'name'
						)
					),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Section position'),
                        'name' => 'itemcount',
                        'desc' => $this->l('The position of the custom fields in the product page'),

                    ),

					/**/



				),
				'submit'      => array(
					'title' => $this->l('Save'),
				)

			),




		);
		$helper                           = new HelperForm();
		$helper->show_toolbar             = true;
		$helper->table                    = $this->table;
		$lang                             = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language    = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_F||M_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_F||M_LANG') : 0;
		$this->fields_form                = array();
		$helper->identifier               = $this->identifier;
		$helper->submit_action            = 'submitCustomize';
		$helper->currentIndex             = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;

		$helper->token    = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages'    => $this->context->controller->getLanguages(),
			'id_language'  => $this->context->language->id
		);
		return $helper->generateForm(array($fields_form));
	}

	private function _displayInfo()
	{
		return $this->display(__FILE__, 'views/templates/hook/infos.tpl');
	}

	private function _displayAdds()
	{
		return $this->display(__FILE__, 'views/templates/hook/adds.tpl');
	}

	public function getContent()
	{
		$errors = '';
		$this->postProcess();
		if (_PS_VERSION_ < '1.6.0.0')
		{

			if (Tools::isSubmit('submitCustomize'))
			{

				$disable = Tools::getValue('disable');

				Configuration::updateValue('CUSTOMIZE_DISABLE', $disable);

				/*write*/

				chmod('../themes/'._THEME_NAME_.'/product.tpl', 0777);
				$str = '';

				if ($fh = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'r'))
				{
					while (!feof($fh))
					
						$str .= fgets($fh);
					
					if ($disable == 'yes')
					{
						if (_PS_VERSION_ < '1.5.0.0')
						

							$str = str_replace('<ul class="idTabs">', '<ul class="idTabs" style="display:none">', $str);
						
						if (_PS_VERSION_ > '1.5.0.0' && _PS_VERSION_ < '1.6.0.0')
						
							$str = str_replace('<div id="idTab10" class="bullet customization_block">', '<div id="idTab10" class="bullet customization_block" style="display:none">', $str);

						
					}
					if ($disable == 'no')
					{
						if (_PS_VERSION_ < '1.5.0.0')
						

							$str = str_replace('<ul class="idTabs" style="display:none">', '<ul class="idTabs">', $str);
						
						if (_PS_VERSION_ > '1.5.0.0' && _PS_VERSION_ < '1.6.0.0')
						
							$str = str_replace('<div id="idTab10" class="bullet customization_block" style="display:none">', '<div id="idTab10" class="bullet customization_block">', $str);

						
					}
					fclose($fh);
					@chmod('../themes/'._THEME_NAME_.'/product.tpl', 0644);
				}
				else
				
					die ('Error opening file in '.__FILE__.' on line '.__LINE.'.');
				
				$x42 = fopen('../themes/'._THEME_NAME_.'/product.tpl', 'w');
				fwrite($x42, $str);


				/**/
				$this->_html .= @$errors == '' ? $this->displayConfirmation('Settings updated successfully') : @$errors;

			}

			return $this->displayForm();
		}
		else
			return $this->postProcess().$this->_displayInfo().$this->renderForm().$this->_displayAdds();
	}

	public function getProductscath($id_product)
	{
		$result = Db::getInstance()->getRow('
		
		SELECT SUM(od.`product_quantity`) AS totalCount
		
		FROM '._DB_PREFIX_.'order_detail od 
		WHERE od.product_id = '.$id_product.'');

		return $result['totalCount'];

	}

	public function hookHeader($params)
	{
		$disablef = Configuration::get('CUSTOMIZE_DISABLE');
		$this->context->smarty->assign(array(
			'disablef'  => $disablef,
			'psversion' => _PS_VERSION_
		));

		if (_PS_VERSION_ > '1.4.0.0' && _PS_VERSION_ < '1.5.0.0')
		{
			Tools::addCSS(__PS_BASE_URI__.'modules/customize/css/style.css', 'all');
			if ($disablef == 'yes')
			
				Tools::addCSS(__PS_BASE_URI__.'modules/customize/css/disable.css', 'all');
			
		}
		if (_PS_VERSION_ > '1.5.0.0')
		{
			$this->context->controller->addCSS(($this->_path).'css/style.css', 'all');
			if ($disablef == 'yes')
			
				$this->context->controller->addCSS(($this->_path).'css/disable.css', 'all');
			
		}
		return $this->display(__FILE__, 'views/templates/front/customize-header.tpl');
	}

	public function hookExtraLeft($params)
	{
		return $this->hookExtraRight($params);
	}
	/*public function hookProductActions($params)
	{
		return $this->hookExtraRight($params);
	}*/

	public function hookExtraRight($params)
	{
		$feat       = new Product;
		$itemcount = Configuration::get('CUSTOMIZE_ITEMCOUNT');
		$disable = Configuration::get('CUSTOMIZE_DISABLE');
		$cookie     = '';
		$id_product = (int)(Tools::getValue('id_product'));
		if (_PS_VERSION_ > '1.5.0.0')
		{
			$product  = new Product($id_product, true, $this->context->language->id, $this->context->shop->id);
			$files    = $this->context->cart->getProductCustomization($product->id, Product::CUSTOMIZE_FILE, true);
			$pictures = array();
			foreach ($files as $file)
				$pictures['pictures_'.$product->id.'_'.$file['index']] = $file['value'];

			$texts       = $this->context->cart->getProductCustomization($product->id, Product::CUSTOMIZE_TEXTFIELD, true);
			$text_fields = array();
			foreach ($texts as $text_field)
				$text_fields['textFields_'.$product->id.'_'.$text_field['index']] = str_replace('<br />', "\n", $text_field['value']);
			$this->context->smarty->assign(array(
				'pictures'            => $pictures,
				'customizationFields' => ($product->customizable) ? $product->getCustomizationFields($this->context->language->id) : false,
				'textFields'          => $text_fields
			));
		}
		else
		{
			$product    = new Product($id_product, true, $cookie->id_lang);
			$files      = $cookie->getFamily('pictures_'.(int)($product->id));
			$textFields = $cookie->getFamily('textFields_'.(int)($product->id));
			foreach ($textFields as $key => $textField)
				$textFields[$key] = str_replace('<br />', "\n", $textField);
			$this->context->smarty->assign(array(
				'pictures'            => $files,
				'customizationFields' => ($product->customizable ? $product->getCustomizationFields($this->context->language->id) : false),
				'ipa_customization'   => Tools::getIsset('ipa_customization') ? Tools::getValue('ipa_customization') : '',
				'textFields'          => $textFields
			));

			/* Customize / Values */
			/*	$customize = $product->getFrontCustomize((int)$cookie->id_lang);*/
			$attachments = ($product->cache_has_attachments ? $product->getAttachments((int)$cookie->id_lang) : array());

		}


		$this->context->smarty->assign(array(
			'product' => $product,
			'disable' => $disable,
			'itemcount' => $itemcount-1,
			'psversion',
			_PS_VERSION_

		));
if (_PS_VERSION_ > '1.6.0.0')
		return $this->display(__FILE__, 'views/templates/front/customize2.tpl');
		else
		return $this->display(__FILE__, 'views/templates/front/customize.tpl');
		
	}

}

?>